%define build_modules   1
%{?_with_modules: %global build_modules 1}

%define enable_jasper   1
%{?_with_jasper: %global enable_jasper 1}

%define enable_graphwiz 1
%{?_with_graphwiz: %global enable_graphwiz 1}

%define upstream_name   GraphicsMagick
%define major		3
%define libname         %mklibname %{name} %{major}
%define ppmajor		12
%define libppname       %mklibname %{name}++ %{ppmajor}
%define libwandname     %mklibname graphicsmagickwand 2
%define develname       %mklibname %{name} -d
%define qlev            Q8

Summary:        An X application for displaying and manipulating images
Name:           graphicsmagick
Version:        1.3.27
Release:        %mkrel 1
License:        GPLv2+
Group:          Graphics/Editors and Converters
URL:            http://www.graphicsmagick.org/
Source0:        http://downloads.sourceforge.net/%{name}/%{upstream_name}-%{version}.tar.xz
Patch0:         GraphicsMagick-1.3.15-use-so-for-modules.patch
Patch1:         GraphicsMagick-1.3.16-perl-link.patch

# Upstream patches
BuildRequires:  x11-proto-devel
BuildRequires:  perl-devel
BuildRequires:  freetype2-devel
BuildRequires:  tiff-devel
BuildRequires:  png-devel
BuildRequires:  jpeg-devel
BuildRequires:  jasper-devel
BuildRequires:  libwmf-devel
BuildRequires:  zlib-devel
BuildRequires:  bzip2-devel
BuildRequires:  libxml2-devel
BuildRequires:  lcms-devel
BuildRequires:  lcms2-devel
BuildRequires:  libgs-devel
BuildRequires:  libtool-devel
BuildRequires:  jbigkit-devel
BuildRequires:	chrpath

%description
GraphicsMagick is the swiss army knife of image processing. It
provides a robust collection of tools and libraries which support
reading, writing, and manipulating an image in over 88 major formats
including important formats like DPX, GIF, JPEG, JPEG-2000, PNG, PDF,
SVG, and TIFF. GraphicsMagick supports huge images on systems that
support large files, and has been tested with gigapixel-size images.
GraphicsMagick can create new images on the fly, making it suitable
for building dynamic Web applications. GraphicsMagick may be used to
resize, rotate, sharpen, color reduce, or add special effects to an
image and save the result in the same or differing image format.
Image processing operations are available from the command line, as
well as through C, C++, Perl, or Windows COM programming interfaces.
Extensions are available from third-parties to support programming in
Python, Tcl, and Ruby. With some modification, language extensions for
ImageMagick may be used.

%files
%doc ChangeLog *.txt
%{_bindir}/gm
%dir %{_libdir}/GraphicsMagick-%{version}/config
%{_libdir}/GraphicsMagick-%{version}/config/*.mgk
%dir %{_datadir}/GraphicsMagick-%{version}/config
%{_datadir}/GraphicsMagick-%{version}/config/*.mgk
%if %build_modules
%dir %{_libdir}/%{upstream_name}-%{version}/modules-%{qlev}
%{_libdir}/%{upstream_name}-%{version}/modules-%{qlev}/filters
%dir %{_libdir}/%{upstream_name}-%{version}/modules-%{qlev}/coders
%{_libdir}/%{upstream_name}-%{version}/modules-%{qlev}/coders/*.so
%endif
%{_mandir}/man1/GraphicsMagick++-config.1.*
%{_mandir}/man1/GraphicsMagick-config.1.*
%{_mandir}/man1/GraphicsMagickWand-config.1.*
%{_mandir}/man1/gm.1.*
%{_mandir}/man4/miff.4.*
%{_mandir}/man5/quantize.5.*

#--------------------------------------------------------------

%package -n     %{libname}
Summary:        %upstream_name libraries
Group:          System/Libraries

%description -n %{libname}
This package contains the libraries needed to run programs dynamically
linked with GraphicsMagick libraries.

%files -n %{libname}
%{_libdir}/libGraphicsMagick.so.%{major}*

#--------------------------------------------------------------

%package -n     %{libppname}
Summary:        %upstream_name C++ libraries
Group:          System/Libraries

%description -n %{libppname}
This package contains the libraries needed to run C++ programs dynamically
linked with GraphicsMagick libraries.

%files -n %{libppname}
%{_libdir}/libGraphicsMagick++.so.%{ppmajor}*

#--------------------------------------------------------------

%package -n     %{libwandname}
Summary:        %upstream_name libraries
Group:          System/Libraries

%description -n %{libwandname}
This package contains the libraries needed to run programs dynamically
linked with GraphicsMagick libraries.

%files -n %{libwandname}
%{_libdir}/libGraphicsMagickWand.so.2*

#--------------------------------------------------------------

%package -n     %{develname}
Summary:        Static libraries and header files for %{upstream_name} app development
Group:          Development/C
Provides:       %{name}-devel = %{version}-%{release}
Provides:       %{upstream_name}-devel = %{version}-%{release}
Obsoletes:      %mklibname -d graphicsmagick 1.1.10
Requires:       %{libname} = %{version}
Requires:       %{libppname} = %{version}
Requires:       %{libwandname} = %{version}
Requires:       jbig-devel
%if %{enable_jasper}
Requires:       jasper-devel
%endif
%if %{enable_graphwiz}
Requires:       graphviz-devel
%global __requires_exclude devel\\(libcdt\\)|devel\\(libcircogen\\)|devel\\(libcommon\\)|devel\\(libdotgen\\)|devel\\(libdotneato\\)|devel\\(libfdpgen\\)|devel\\(libgraph\\)|devel\\(libgvrender\\)|devel\\(libneatogen\\)|devel\\(libpack\\)|devel\\(libpathplan\\)|devel\\(libtwopigen\\)|devel\\(libgvc\\)|devel\\(libgvgd\\)
%endif

%description -n %{develname}
If you want to create applications that will use GraphicsMagick code or
APIs, you'll need to install these packages as well as
GraphicsMagick. These additional packages aren't necessary if you simply
want to use GraphicsMagick, however.

graphicsmagick-devel is an addition to GraphicsMagick which includes static
libraries and header files necessary to develop applications.

%files -n %{develname}
%{_bindir}/GraphicsMagick++-config
%{_bindir}/GraphicsMagick-config
%{_bindir}/GraphicsMagickWand-config
%dir %{_includedir}/GraphicsMagick
%{_includedir}/GraphicsMagick/Magick++.h
%dir %{_includedir}/GraphicsMagick/magick
%{_includedir}/GraphicsMagick/magick/*.h
%dir %{_includedir}/GraphicsMagick/Magick++
%{_includedir}/GraphicsMagick/Magick++/*.h
%dir %{_includedir}/GraphicsMagick/wand
%{_includedir}/GraphicsMagick/wand/*.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

#--------------------------------------------------------------

%package -n     perl-Graphics-Magick
Summary:        Libraries and modules for access to %upstream_name from perl
Group:          Development/Perl
Requires:       %{name} = %{version}
%if %{enable_graphwiz}
Requires:       graphviz
%endif

%description -n perl-Graphics-Magick
This is the %upstream_name perl support package. It includes perl modules
and support files for access to GraphicsMagick library from perl.

%files -n perl-Graphics-Magick
%{_mandir}/man3*/*::*.3pm*
%{perl_vendorarch}/Graphics
%{perl_vendorarch}/auto

#--------------------------------------------------------------

%package        doc
Summary:        %{name} Documentation
Group:          Documentation
BuildArch:      noarch

%description    doc
This package contains HTML/PDF documentation of %{name}.

%files doc
%{_datadir}/doc/GraphicsMagick

#--------------------------------------------------------------

%prep
%autosetup -p1 -n %{upstream_name}-%{version}

%build
%define Werror_cflags %nil
%configure2_5x \
    --enable-fast-install \
    --without-dps \
%if %{build_modules}
    --with-modules \
%else
    --without-modules \
%endif
    --enable-shared \
    --disable-static \
    --with-pic \
%if %{enable_jasper}
    --with-jp2 \
%else
    --without-jp2 \
%endif
    --with-perl-options="INSTALLDIRS=vendor"  \
    --with-perl

%make_build
%make_build perl-build

%install
%make_install
%make_install -C PerlMagick

# fix rights and remove rpaths
chmod 755 %{buildroot}%{perl_vendorarch}/auto/Graphics/Magick/Magick.so
chrpath -d %{buildroot}%{perl_vendorarch}/auto/Graphics/Magick/Magick.so

# remove unwanted files
find %{buildroot} -name '*.la' -delete
rm -f %{buildroot}%{_datadir}/GraphicsMagick-%{version}/{ChangeLog,NEWS.txt}


%changelog
* Tue Dec 12 2017 ns80 <ns80> 1.3.27-1.mga5
+ Revision: 1182440
- new version 1.3.27 that corrects many security issues (mga#21600)
- add upstream patches for CVE-2016-868[2-4] (mga#19602)
- add an upstream patch for two issues in the WPG reader (mga#19506)
- add a patch for CVE-2016-7800 (mga#19506)

  + neoclust <neoclust>
    - Add P103 - Fixes CVE-2017-12937 (mga#21564)
    - Add P102 - Fixes CVE-2017-12936 (mga#21564)
    - Add P101 - Fixes CVE-2017-12935 (mga#21564)
    - Add P7 - Fixes CVE-2017-6335 (mga#19668)

  + akien <akien>
    - Fix use-after-free crash (CVE-2017-11403)
    - Version 1.3.26, many security fixes (mga#19668)

  + luigiwalser <luigiwalser>
    - 1.3.25
    - remove upstream patch 2
    - add upstream patch to fix more svg security issues
    - add upstream patch to fix CVE-2015-8808

  + philippem <philippem>
    - revert move libGraphicsMagick++.so mga#17714#72
    - move libGraphicsMagick++.so as it was before last update mga#17714#c51
    - update to 1.3.24, mga#17714, security fixes
    - add patches to fix CVE-2016-2317 and CVE-2016-2318 mga#17714

* Fri Nov 14 2014 luigiwalser <luigiwalser> 1.3.20-4.mga5
+ Revision: 796898
- add upstream patch to fix CVE-2014-8355

* Wed Oct 15 2014 umeabot <umeabot> 1.3.20-3.mga5
+ Revision: 746200
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.3.20-2.mga5
+ Revision: 679929
- Mageia 5 Mass Rebuild

  + tv <tv>
    - use %%global for req/prov exclude
    - autoconvert to new prov/req excludes

* Fri Aug 29 2014 luigiwalser <luigiwalser> 1.3.20-1.mga5
+ Revision: 669268
- 1.3.20
- add patch from fedora to fix CVE-2014-1947

* Sun Aug 17 2014 wally <wally> 1.3.19-1.mga5
+ Revision: 664839
- rediff perl module linking patch to fix build
- drop rpath from perl module

  + spuhler <spuhler>
    - upgrade to ver. 1.3.19
    - removed invalid config option --disable-ltdl-install

  + pterjan <pterjan>
    - Rebuild for perl 5.20

* Sat Oct 19 2013 umeabot <umeabot> 1.3.18-3.mga4
+ Revision: 526031
- Mageia 4 Mass Rebuild

  + akien <akien>
    - Fixed description references to ImageMagick instead of GraphicsMagick
    - Cleaned spec file (inconsistant use of tabs and spaces)

* Mon Jun 03 2013 fwang <fwang> 1.3.18-2.mga4
+ Revision: 435527
- rebuild for new libpng

* Wed May 29 2013 fwang <fwang> 1.3.18-1.mga4
+ Revision: 430311
- new version 1.3.18

* Sat Jan 12 2013 umeabot <umeabot> 1.3.17-2.mga3
+ Revision: 352565
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

  + boklm <boklm>
    - Update group: Graphics/Editors -> Graphics/Editors and Converters

* Tue Oct 16 2012 fwang <fwang> 1.3.17-1.mga3
+ Revision: 307089
- br ltdl
- drop merged patch
- update rpm group
- new version 1.3.17

* Sat Sep 08 2012 luigiwalser <luigiwalser> 1.3.16-4.mga3
+ Revision: 289832
- add upstream patch to fix CVE-2012-3438

* Wed Aug 01 2012 blino <blino> 1.3.16-3.mga3
+ Revision: 276909
- really link perl module with library

* Mon Jul 09 2012 fwang <fwang> 1.3.16-2.mga3
+ Revision: 269011
- update lcms2

* Mon Jun 25 2012 fwang <fwang> 1.3.16-1.mga3
+ Revision: 263388
- new version 1.3.16

* Thu Jun 14 2012 fwang <fwang> 1.3.15-3.mga3
+ Revision: 260526
- fix bug#6411: graphicsmagick knows nothing about modules

* Sat Jun 02 2012 blino <blino> 1.3.15-2.mga3
+ Revision: 253383
- fail if typemap already exists (to remove the hack when upstream is fixed)

* Sat Jun 02 2012 blino <blino> 1.3.15-1.mga3
+ Revision: 253364
- Add a  simple "ignore this type" style typemap to get past a xsubpp
  exception in recent versions of Perl, from ImageMagick r4950
  (see also rt #70150, gentoo #378197)

  + fwang <fwang>
    - new version 1.3.15
    - rebuild for new perl
    - set doc as noarch

* Fri Jan 13 2012 fwang <fwang> 1.3.13-1.mga2
+ Revision: 195719
- new version 1.3.13

* Fri Dec 23 2011 fwang <fwang> 1.3.12-6.mga2
+ Revision: 186520
- rebuild for new libtiff

* Wed Sep 14 2011 fwang <fwang> 1.3.12-5.mga2
+ Revision: 143446
- update file list
- add gentoo patches to fix build with latest libpng
- drop .la files

* Sun Jun 12 2011 sander85 <sander85> 1.3.12-4.mga2
+ Revision: 104629
- Rebuild for perl 5.14

* Sun Feb 06 2011 spuhler <spuhler> 1.3.12-3.mga1
+ Revision: 47953
- removed the if mdkversion lines  from spec
- imported package graphicsmagick


* Sun Aug 01 2010 Funda Wang <fwang@mandriva.org> 1.3.12-3mdv2011.0
+ Revision: 564247
- rebuild for perl 5.12.1

* Wed Jul 21 2010 Jérôme Quelin <jquelin@mandriva.org> 1.3.12-2mdv2011.0
+ Revision: 556444
- perl 5.12 rebuild

* Tue Apr 27 2010 Funda Wang <fwang@mandriva.org> 1.3.12-1mdv2010.1
+ Revision: 539441
- new version 1.3.12

* Mon Feb 22 2010 Funda Wang <fwang@mandriva.org> 1.3.11-1mdv2010.1
+ Revision: 509406
- New version 1.3.11

* Thu Feb 11 2010 Frederik Himpe <fhimpe@mandriva.org> 1.3.10-1mdv2010.1
+ Revision: 504290
- update to new version 1.3.10

* Fri Feb 05 2010 Funda Wang <fwang@mandriva.org> 1.3.9-1mdv2010.1
+ Revision: 501074
- update to new version 1.3.9

* Fri Jan 22 2010 Frederik Himpe <fhimpe@mandriva.org> 1.3.8-1mdv2010.1
+ Revision: 495074
- Update to new version 1.3.8
- Remove CVE-2009-3736 patch integrated upstream

* Sun Jan 10 2010 Oden Eriksson <oeriksson@mandriva.com> 1.3.7-3mdv2010.1
+ Revision: 488759
- rebuilt against libjpeg v8
- P1: security fix for CVE-2009-3736

* Thu Sep 24 2009 Frederik Himpe <fhimpe@mandriva.org> 1.3.7-1mdv2010.0
+ Revision: 448498
- Update to new version 1.3.7
- Disable static libraries
- Fix perl build (Fedora)

* Sat Aug 15 2009 Oden Eriksson <oeriksson@mandriva.com> 1.3.5-4mdv2010.0
+ Revision: 416519
- rebuilt against libjpeg v7

* Wed Apr 08 2009 Helio Chissini de Castro <helio@mandriva.com> 1.3.5-3mdv2009.1
+ Revision: 365216
- Install package required wrong namiing to x86_64 libs

* Sat Apr 04 2009 Funda Wang <fwang@mandriva.org> 1.3.5-2mdv2009.1
+ Revision: 364040
- add more BRs

* Fri Jan 30 2009 Funda Wang <fwang@mandriva.org> 1.3.5-1mdv2009.1
+ Revision: 335524
- New version 1.3.5

* Sat Jan 17 2009 Funda Wang <fwang@mandriva.org> 1.3.4-1mdv2009.1
+ Revision: 330710
- disable format check
- New version 1.3.4

  + Oden Eriksson <oeriksson@mandriva.com>
    - lowercase ImageMagick

* Thu Dec 11 2008 Funda Wang <fwang@mandriva.org> 1.3.3-1mdv2009.1
+ Revision: 312645
- gcc patch not needed
- New version 1.3.3

* Sun Nov 30 2008 Funda Wang <fwang@mandriva.org> 1.3.2-1mdv2009.1
+ Revision: 308490
- New version 1.3.2

* Tue Sep 02 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2.5-2mdv2009.0
+ Revision: 279103
- fix build

* Sun Jul 27 2008 Funda Wang <fwang@mandriva.org> 1.2.5-1mdv2009.0
+ Revision: 250518
- update to new version 1.2.5

* Sun Jul 06 2008 Funda Wang <fwang@mandriva.org> 1.2.4-1mdv2009.0
+ Revision: 232196
- New version 1.2.4

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Sun Jun 08 2008 Funda Wang <fwang@mandriva.org> 1.2.3-1mdv2009.0
+ Revision: 216863
- New version 1.2.3

* Thu May 29 2008 Funda Wang <fwang@mandriva.org> 1.2.2-1mdv2009.0
+ Revision: 213102
- New version 1.2.2

* Wed May 21 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2.1-2mdv2009.0
+ Revision: 209716
- added a gcc43 patch from fedora

* Wed May 07 2008 Funda Wang <fwang@mandriva.org> 1.2.1-1mdv2009.0
+ Revision: 203086
- fix file list
- New version 1.2.1

* Fri May 02 2008 Funda Wang <fwang@mandriva.org> 1.2-1mdv2009.0
+ Revision: 199934
- New version 1.2

  + Thierry Vignaud <tv@mandriva.org>
    - fix no-buildroot-tag

* Sun Feb 03 2008 Funda Wang <fwang@mandriva.org> 1.1.10-3mdv2008.1
+ Revision: 161611
- split out libs to reflect the actual soname

* Mon Jan 21 2008 Thierry Vignaud <tv@mandriva.org> 1.1.10-2mdv2008.1
+ Revision: 155648
- rebuild for new perl

* Fri Dec 21 2007 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.1.10-1mdv2008.1
+ Revision: 136151
- Fix File list
- import graphicsmagick


